; Reinhard LAMMINGER Juni 1994
; HTBLA Ortweinschule
; Ortweingasse 4, 8013 Graz
; Zeichen einer Klebelasche

(defun c:lasche ( / p1 p2 a p3 p4 osm eps w2)
; Laschenbreite B global

      (setvar "CMDECHO" 0)
      (setq eps 1.0E-05   w2 (sqrt 2.0) )
      (if (not b) (setq b 1.0)) ; default

      ; Punke eingeben
      (setq p1 (getpoint "\nPunkt 1: "))
      (setq p2 (getpoint "\nPunkt 2: "))

      ; Plausibilitaetstest
      (setq a (distance p1 p2))
      (if (< a eps)
      (progn
            (alert "Punkte ident !")
            (exit)
      ))

      ; Breite eingeben
      (setq b   (zahl "\nLaschenbreite" b))

      ; Punkte berechnen und Lasche zeichnen
      (setq phi (angle p1 p2))
      (setq osm (getvar "OSMODE"))
      (setvar "OSMODE" 0)

      (if (<= a (* 2.0 b))
      (progn ; Dreieck
            (setq p3 (polar p1 (- phi (* 0.25 pi)) (* 0.5 a w2) ))
            (command "_pline" p1 p3 p2 "")
      )(progn ; Trapez
            (setq p3 (polar p1 (- phi (* 0.25 pi)) (* b w2) ))
            (setq p4 (polar p2 (+ phi (* 1.25 pi)) (* b w2) ))
            (command "_pline" p1 p3 p4 p2 "")
      ));endif
      (setvar "OSMODE" osm)

      (princ)
)
            
(defun zahl (prompt z / s p r)
; Eingabeprompt mit Defaultwert
; als Textstring bestimmen
      (if z
            (setq s (rtos z))
            (setq s " ")
      )
      (setq p (strcat prompt " <" s ">: "))
      (initget 0)
      (setq r (getreal p))
      (if r
            (setq r r)
            (setq r z)
      )
)
