;*******************************************;
;			<<< TEXTFELD.LSP >>>			;
;*******************************************;

;Autor: K.Habenicht
;Datum der Erstellung: 3.3.1993
;Datum der letzten Vernderung: 10.10.1994
;Funktion: Textfeld ausfllen von A4QUER
;************** Programm *******************;

;Fehlerroutine
(defun *error* (msg)
(princ msg)
(setvar "CMDECHO" cmd)
(setvar "BLIPMODE" blip)
(setvar "CLAYER" altlay)
(setvar "TILEMODE" tile)
(setvar "OSMODE" of)
(princ)
)

;Hauptprogramm
(defun C:TEXTFELD (/ Datum Name Masstab Titel ZN)
;Sichern der Systemvariablen
(setq cmd (getvar "CMDECHO"))
(setq blip (getvar "BLIPMODE"))
(setq altlay (getvar "CLAYER"))
(setq tile (getvar "TILEMODE"))
(setq of (getvar "OSMODE"))
;Eingabeteil
(setq Datum (getstring T "\nDatum: ")
	  Name (getstring T "\nKonstrukteur: ")
	  Masstab (getstring T "\nMastab: ")
	  Titel (getstring T "\nTitel: ")
	  ZN (getstring T "\nZeichnungsnummer: ")
)
;Setzen der Systemvariablen
(setvar "CMDECHO" 0)
(setvar "BLIPMODE" 0)
(setvar "TILEMODE" 0)
(setvar "OSMODE" 0)
(setvar "CLAYER" "Text2")
;Schriftfeld ausfllen
(command "TEXT" '(189 28) 2 0 Datum
		 "TEXT" '(209 28) 2 0 Name
)
(setvar "CLAYER" "Text1")
(command "TEXT" '(169 9) 5 0 Masstab
		 "TEXT" '(189 9) 5 0 Titel
		 "TEXT" '(264 9) 5 0 ZN
)
;Rcksetzen der Systemvariablen
(setvar "CMDECHO" cmd)
(setvar "BLIPMODE" blip)
(setvar "CLAYER" altlay)
(setvar "TILEMODE" tile)
(setvar "OSMODE" of)
(princ)
)
